#! /bin/sh
#***********************************************************************#
# QLogic nx_nic blacklisting script
# Copyright (C) 2012-2014 QLogic Corporation
# (www.qlogic.com)
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# A copy of the GNU General Public License, version 2 can be found at
# http://www.gnu.org/licenses/gpl-2.0.txt
#***********************************************************************#

# If the GPL Nic driver exists on this machine then blacklist it.

# If a blacklist file exists put an entry in it otherwise put it in a modprobe file.

exec_script="/usr/bin/nx_snmp.pl"
mid_obj_id=".1.3.6.1.2.1.10.7.11.1"
pass_entry="pass ${mid_obj_id} ${exec_script}"
snmpd_conf="/etc/snmp/snmpd.conf"
netxen_driver=`modinfo netxen_nic  > /dev/null 2>&1 && echo "yes" || echo "no"`
bl_files="/etc/modprobe.d/blacklist /etc/hotplug/blacklist  /etc/modprobe.d/blacklist.conf /etc/modprobe.conf.local /etc/modprobe.conf /etc/modules.conf"
blacklist_file=""
for f in $bl_files
do
	if [ -f $f ]; then
		blacklist_file=$f
		break
	else
		blacklist_file=""
	fi
done

if [ "$blacklist_file" == "" ]; then
	touch /etc/modprobe.d/blacklist.conf
	blacklist_file=/etc/modprobe.d/blacklist.conf
fi

if [ "$blacklist_file" != "/etc/hotplug/blacklist" ]; then
	blacklist_entry="blacklist netxen_nic"
	blacklist_nx_xport="blacklist nx_xport"
else
	blacklist_entry="netxen_nic"
	blacklist_nx_xport="nx_xport"
fi

modprob_conf="/etc/modprobe.conf"

if [ ${netxen_driver} == "yes" ]; then
    if ! grep -q "${blacklist_entry}" ${blacklist_file}; then
        echo "${blacklist_entry}" >> ${blacklist_file}
    fi

    if ! grep -q "${blacklist_nx_xport}" ${blacklist_file}; then
	echo "${blacklist_nx_xport}" >> ${blacklist_file}
    fi
    if [ -f ${modprob_conf} ]; then
        if ! grep -q -E "install netxen_nic /sbin/modprobe nx_nic" ${modprob_conf}; then
            echo "install netxen_nic /sbin/modprobe nx_nic" >> ${modprob_conf}
        fi
        if ! grep -q -E "install nx_xport /bin/true" ${modprob_conf}; then
            echo "install nx_xport /bin/true" >> ${modprob_conf}
        fi
    fi
fi

which mkinitrd &>/dev/null
if [ $? -eq 0 ];then
	mkinitrd &> /dev/null
	if [ $? -ne 0 ];then
		mkinitrd /boot/initramfs-`uname -r`.img `uname -r` --force &> /dev/null
		if [ $? -eq 0 ];then
			echo "Updated initrd/initramfs successfully"
		fi
	else
		echo "Updated initrd/initramfs successfully"
	fi
fi

depmod
if [ -f ${snmpd_conf} ]; then
    if ! grep -q "${pass_entry}" ${snmpd_conf}; then
        echo "${pass_entry}" >> ${snmpd_conf}
    fi
fi

